import json
import os

import jmespath
from importers.taxonomy import converter

'''
Creates testdata for tests/integration_tests/test_convert_occupation_value_temp.py  
'''
currentdir = os.path.dirname(os.path.realpath(__file__)) + '/'
output_file_name = 'occupation_value.py'

def read_input_occupation_data():
    '''
    The file occupations_query_v21_output.json was generated by:
    1. Go to https://taxonomy.api.jobtechdev.se/v1/taxonomy/graphiql
    2. Execute OCCUPATIONS_QUERY that's declared in importers/taxonomy/queries.py (replace 'version: %s' with 'version: "21"')
    '''

    query_v21_output_path = f'{currentdir}./util_resources/occupations_query_v21_output.json'
    with open(query_v21_output_path, 'r', encoding='utf-8') as f:
        data = json.load(f)
    return data

def create_occupation_testdata():

    occupation_data = read_input_occupation_data()

    concepts = jmespath.search('data.concepts', occupation_data)

    new_occupation_data = []
    for concept in concepts:
        expected = converter.convert_occupation_value(concept)
        entry = {"input": concept, "expected": expected}
        new_occupation_data.append(entry)
    with open(output_file_name, 'w', encoding='utf-8') as f:
        f.write('occupation_test_data = [')
        for new_occupation in new_occupation_data:
            json_to_write = json.dumps(new_occupation, ensure_ascii=False)
            json_to_write = json_to_write.replace('null', 'None')
            json_to_write = json_to_write.replace('\"', '\'')
            f.write(json_to_write)
            f.write(',\n')
        f.write(']')
        f.close()
    print(f'File {output_file_name} saved. Now copy the file to jobsearch-importers/tests/integration_tests/test_resources/{output_file_name}')


create_occupation_testdata()